package net.universe_factory.minecraft.test.blocks;

import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemDye;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.universe_factory.minecraft.test.Test;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class BlockGlowfoo extends Block {
	private static final IIcon[] textures = new IIcon[16];

	public BlockGlowfoo() {
		super(Material.glass);

		setHardness(0.3F);
		setStepSound(soundTypeGlass);
		setLightLevel(1.0F);
		setCreativeTab(CreativeTabs.tabDecorations);
		setBlockName("glowfoo");
		setBlockTextureName(Test.MODID + ":glowfoo");
	}

	@SideOnly(Side.CLIENT)
	public void getSubBlocks(Item item, CreativeTabs creativeTabs, List list) {
		for (int i = 0; i < textures.length; i++)
			list.add(new ItemStack(item, 1, i));
	}

	@SideOnly(Side.CLIENT)
	public IIcon getIcon(int side, int meta) {
		return textures[meta % textures.length];
	}

	@SideOnly(Side.CLIENT)
	private static int negateMeta(int meta) {
		return ~meta & 15;
	}

	@SideOnly(Side.CLIENT)
	public void registerBlockIcons(IIconRegister iconRegister) {
		for (int i = 0; i < textures.length; i++)
			textures[i] = iconRegister.registerIcon(this.getTextureName() + "_" + ItemDye.field_150921_b[negateMeta(i)]);
	}

	public int damageDropped(int meta) {
		return meta;
	}
}
