package net.universe_factory.minecraft.test.generic;

import net.minecraft.block.BlockCrops;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.item.Item;
import net.minecraft.util.IIcon;
import net.universe_factory.minecraft.test.Test;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public abstract class GenericCrops extends BlockCrops {
	@SideOnly(Side.CLIENT)
	private IIcon[] icons;

	protected GenericCrops() {
		setBlockName(getName());
		setBlockTextureName(Test.MODID + ":" + getName().toLowerCase());
	}

	@SideOnly(Side.CLIENT)
	public IIcon getIcon(int side, int meta) {
		if (meta < 7) {
			if (meta == 6) {
				meta = 5;
			}

			return this.icons[meta >> 1];
		} else {
			return this.icons[3];
		}
	}

	protected Item func_149866_i() {
		return itemSeeds();
	}

	protected Item func_149865_P() {
		return itemCrops();
	}

	@SideOnly(Side.CLIENT)
	public void registerBlockIcons(IIconRegister iconRegister) {
		this.icons = new IIcon[4];

		for (int i = 0; i < this.icons.length; ++i) {
			this.icons[i] = iconRegister.registerIcon(this.getTextureName() + "_stage_" + i);
		}
	}

	public abstract String getName();

	public abstract Item itemCrops();

	public abstract Item itemSeeds();
}
